var ENGINE = require("Engine");

// class Vector2
// -----------------------------------------------------------
ENGINE.Vector2 = function (x, y) {
  this.x = x || 0;
  this.y = y || 0;
};

ENGINE.Vector2.prototype = {

  constructor: ENGINE.Vector2,

  length: function length() {
    return Math.sqrt(this.x * this.x + this.y * this.y);
  },

  /** @description subtract vector a minus b and assign the result to this vector  
   * @param {ENGINE.Vector2} a first vector  
   * @param {ENGINE.Vector2} b second vector
   * @return {ENGINE.Vector2} this
   */
  subVectors: function subVectors(a, b) {
    this.x = a.x - b.x;
    this.y = a.y - b.y;

    return this;
  },

  toString: function toString() {
    return 'Vector2: (x: ' + this.x.toString() + ', y:' + this.y.toString() + ')';
  }

};